## brewtarget 2.0.2

=== CMakeLists.txt ===
PROJECT(brewtarget)
cmake_minimum_required(VERSION 2.8)

# Creates a Makefile.
# NOTE: cmake . -DCMAKE_INSTALL_PREFIX=/tmp/blah && make DESTDIR=/foo
# will install to /foo/tmp/blah.

# Where the binary goes.
SET(brewtarget_EXECUTABLE "brewtarget")

#=================================Version======================================
SET( brewtarget_VERSION_MAJOR 2 )
SET( brewtarget_VERSION_MINOR 0 )
SET( brewtarget_VERSION_PATCH 2 )
SET( brewtarget_VERSION_STRING "${brewtarget_VERSION_MAJOR}.${brewtarget_VERSION_MINOR}.${brewtarget_VERSION_PATCH}" )

#===================================Options====================================
OPTION( BUILD_DESIGNER_PLUGINS
        "If on, you will only build and install the designer plugins."
        OFF )
OPTION( DO_RELEASE_BUILD
        "If on, will do a release build. Otherwise, debug build."
        OFF )
OPTION( ENABLE_PROFILING
        "If on, builds with necessary profiling options."
        OFF )
OPTION( NO_PHONON
        "If on, does not build any Phonon code."
        OFF )
OPTION( NO_MESSING_WITH_FLAGS
        "On means do not add any build flags whatsoever. May override other options."
        OFF )
#==============================Compile flags===================================
IF( NOT ${NO_MESSING_WITH_FLAGS} )
   IF( CMAKE_COMPILER_IS_GNUCXX )
      SET( CMAKE_CXX_FLAGS_RELEASE "-Wall -ansi -pedantic -Wno-long-long -O2" )
      SET( CMAKE_CXX_FLAGS_DEBUG "-Wall -g3" )
   ENDIF()

   # Speed up compilation if using gcc.
   IF( UNIX AND NOT APPLE )
      SET( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -pipe" )
      SET( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pipe" )
   ENDIF()

   IF( ${ENABLE_PROFILING} )
      SET( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pg" )
   ENDIF()
ENDIF()

IF( ${NO_PHONON} )
   ADD_DEFINITIONS( -DNO_PHONON )
ENDIF()

IF( ${DO_RELEASE_BUILD} )
   SET( CMAKE_BUILD_TYPE "Release" )
ELSE()
   SET( CMAKE_BUILD_TYPE "Debug" )
ENDIF()

IF( APPLE AND NOT CMAKE_OSX_ARCHITECTURES )
   SET( CMAKE_OSX_ARCHITECTURES i386 x86_64 ) # Build intel binary. 
   #SET( CMAKE_OSX_ARCHITECTURES ppc i386 ppc64 x86_64 ) # Build universal binary.
ENDIF()

#============================Directories=======================================
SET(ROOTDIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(SRCDIR "${ROOTDIR}/src")
SET(UIDIR "${ROOTDIR}/ui")
SET(DATADIR "${ROOTDIR}/data")
SET(TRANSLATIONSDIR "${ROOTDIR}/translations")
SET(WINDIR "${ROOTDIR}/win")

INCLUDE_DIRECTORIES(${SRCDIR})
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/src") # In case of out-of-source build.
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/QtDesignerPlugins")

# Custom cmake modules.
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules" )

#==============================OS-specific Commands============================
IF( UNIX )
   SET( RM_COMMAND "rm" )
   SET( RM_ARGS "-f" )
ELSEIF( WIN32 )
   SET( RM_COMMAND "del" )
   SET( RM_ARGS "" )
ENDIF()

# ======================Find Qt4 (>= 4.6.0) for this project===================
IF( ${BUILD_DESIGNER_PLUGINS} )
   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebKit QtXml QtDesigner REQUIRED)
ELSE()
   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebkit QtXml REQUIRED)
ENDIF()

MESSAGE( STATUS "CMAKE_SYSTEM_INCLUDE_PATH: ${CMAKE_SYSTEM_INCLUDE_PATH}" )

# Some distros seem to treat Qt and Phonon as separate, so try to find Phonon.
IF( NOT ${NO_PHONON} )
   FIND_PACKAGE( Phonon REQUIRED )
   INCLUDE_DIRECTORIES(${PHONON_INCLUDES})
ENDIF()

# Warn if the sqlite plugin is not found.
IF( NOT QT_QSQLITE_PLUGIN_RELEASE )
   MESSAGE( WARNING "Qt4 sqlite runtime plugin not found. On Debian, the package is libqt4-sql-sqlite." )
ENDIF()

# Some extra files for the "make clean" target.
SET_PROPERTY(
   DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
   PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
   ".*~$" # Kate backup files.
   "CMakeLists.txt.user" # From QtCreator I think.
   "CPackConfig.cmake"
   "CPackSourceConfig.cmake"
)

#=========================Configure brewtarget.qrc.in==========================

SET( brewtarget_QRC "${CMAKE_CURRENT_SOURCE_DIR}/brewtarget.qrc" )
SET( brewtarget_cfg_QRC "${CMAKE_CURRENT_BINARY_DIR}/brewtarget_cfg.qrc" )
CONFIGURE_FILE( brewtarget_cfg.qrc.in ${brewtarget_cfg_QRC} )

#============================Doxygen Custom Target=============================
FIND_PROGRAM( DOXYGEN_CMD doxygen )
IF( DOXYGEN_CMD )
  SET( DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile" )
  CONFIGURE_FILE( "${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in" ${DOXYFILE} )
  ADD_CUSTOM_TARGET( source_doc
                     COMMAND ${DOXYGEN_CMD} ${DOXYFILE}
                     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
                   )
ENDIF()

#=============================Database Custom Target===========================
FIND_PROGRAM( SQLITE3_CMD sqlite3 )
IF( NOT SQLITE3_CMD )
   MESSAGE( FATAL_ERROR "Did not find sqlite3 to make the database." )
ENDIF()

#=========================Detect Debian======================================== 
IF( EXISTS "/etc/debian_version" )
  MESSAGE( STATUS "Debian detected..." )

  IF( NOT ${CMAKE_INSTALL_PREFIX} STREQUAL "/usr" )
    MESSAGE( WARNING "Debian system, but CMAKE_INSTALL_PREFIX != /usr" )
    MESSAGE( WARNING "CMAKE_INSTALL_PREFIX = \"${CMAKE_INSTALL_PREFIX}\"" )
  ENDIF()
ENDIF()

#========================Construct the directories=============================

# Debian standard directories.
IF( NOT EXEC_PREFIX )
   SET( EXEC_PREFIX ${CMAKE_INSTALL_PREFIX} )
ENDIF()
   
SET( DATAROOTDIR "${EXEC_PREFIX}/share" )
SET( BINDIR "${EXEC_PREFIX}/bin" )
IF( NOT DOCDIR )
   SET( DOCDIR "${DATAROOTDIR}/doc/${CMAKE_PROJECT_NAME}" )
ENDIF()

# Actual install directories.
IF( UNIX AND NOT APPLE )
  SET( DATAPATH "${DATAROOTDIR}/${CMAKE_PROJECT_NAME}" )
  SET( TARGETPATH ${BINDIR} )
  SET( DOCPATH ${DOCDIR} )
ELSEIF( WIN32 )
  # Works for regular "make install", but not CPack/NSIS installer.
  #SET( CMAKE_INSTALL_PREFIX "C:/Program Files/brewtarget-${brewtarget_VERSION_STRING}" )
  #SET( DATAPATH "brewtarget-${brewtarget_VERSION_STRING}" )
  #SET( TARGETPATH "brewtarget-${brewtarget_VERSION_STRING}" )
  #SET( DOCPATH "brewtarget-${brewtarget_VERSION_STRING}/doc" )
  
  # For some damn reason, for the NSIS installer,
  # the prefix needs to be empty. Also, seems that the .exe
  # needs to be in bin/. Fucking piece of shit CPack...
  # Can anybody shed some light on this situation?
  SET( CMAKE_INSTALL_PREFIX "" )
  SET( DATAPATH "data" )
  SET( TARGETPATH "bin" )
  SET( DOCPATH "doc" )
ELSEIF( APPLE )
  SET( CMAKE_INSTALL_PREFIX "/" )
  SET( BT_BUNDLE "brewtarget.app" )
  SET( BT_BUNDLE_DIR "/Applications/${BT_BUNDLE}" )
  SET( DATAPATH "${BT_BUNDLE_DIR}/Contents/Resources" )
  SET( TARGETPATH "${BT_BUNDLE_DIR}/Contents/MacOS" )
  SET( DOCPATH  "${BT_BUNDLE_DIR}/Contents/Resources/en.lproj" )
ENDIF()

#=========================Configure brewtarget.desktop=========================

# If it begins with a '/'
IF( IS_ABSOLUTE ${DATAROOTDIR} )
   SET( brewtarget_ICONS_LOCATION "${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
ELSE()
   SET( brewtarget_ICONS_LOCATION "/${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
ENDIF()

CONFIGURE_FILE( brewtarget.desktop.in brewtarget.desktop )

#==============================Setup the config.h==============================

# "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
# by the below corresponding value in ${CONFIGDATADIR} below when
# CONFIGURE_FILE() is called.
IF( ${DATAPATH} MATCHES "^/" )
   SET( CONFIGDATADIR "${DATAPATH}/" )
ELSE()
   SET( CONFIGDATADIR "/${DATAPATH}/" )
ENDIF()

IF( ${DOCPATH} MATCHES "^/" )
   SET( CONFIGDOCDIR "${DOCPATH}/" )
ELSE()
   SET( CONFIGDOCDIR "/${DOCPATH}/" )
ENDIF()

# Tell cmake where the configure file is and where
# to put the output. All variables in config.in written as "${VAR}$
# will be replaced by VAR as determined by cmake in config.h.
# Outputs only in the build directory.
CONFIGURE_FILE( src/config.in src/config.h )

#================================Files=========================================

# List of documentation files to be installed.
SET( brewtarget_DOCS
     ${ROOTDIR}/README.markdown
     ${ROOTDIR}/COPYRIGHT
)

# List of data files to be installed.
SET( brewtarget_DATA
     ${DATADIR}/default_db.sqlite
     ${DATADIR}/options.xml
# Yes, I know this is 'documentation', but Debian policy suggests it should be
# with the data (see section 12.3 of the policy manual).
     ${ROOTDIR}/doc/brewtarget-manual.html
)

# Desktop files to install.
# This is not prefixed with ${ROOTDIR} b/c it is a configured file that will
# only exist in the build directory.
SET( brewtarget_DESKTOP
     ${CMAKE_CURRENT_BINARY_DIR}/brewtarget.desktop
)

# Icon files to install.
SET( brewtarget_ICONS
     ${ROOTDIR}/images/brewtarget_icon.svg
)

SET( TRANSLATIONS_FILES
     ${TRANSLATIONSDIR}/bt_ca.ts # Catalan
     ${TRANSLATIONSDIR}/bt_cs.ts # Czech
     ${TRANSLATIONSDIR}/bt_de.ts # German
     ${TRANSLATIONSDIR}/bt_en.ts # English
     ${TRANSLATIONSDIR}/bt_el.ts # Greek
     ${TRANSLATIONSDIR}/bt_es.ts # Spanish
     ${TRANSLATIONSDIR}/bt_fr.ts # French
     ${TRANSLATIONSDIR}/bt_nb.ts # Norwegian Bokmal
     ${TRANSLATIONSDIR}/bt_it.ts # Italian
     ${TRANSLATIONSDIR}/bt_nl.ts # Dutch
     ${TRANSLATIONSDIR}/bt_pl.ts # Polish
     ${TRANSLATIONSDIR}/bt_pt.ts # Portuguese
     ${TRANSLATIONSDIR}/bt_hu.ts # Hungarian
     ${TRANSLATIONSDIR}/bt_ru.ts # Russian
     ${TRANSLATIONSDIR}/bt_sv.ts # Swedish
     ${TRANSLATIONSDIR}/bt_zh.ts # Chinese
)

SET( RCFILE ${WINDIR}/icon.rc )

SET( brewtarget_SOUNDS
     ${DATADIR}/sounds/45minLeft.mp3
     ${DATADIR}/sounds/addFuckinHops.mp3
     ${DATADIR}/sounds/aromaHops.mp3
     ${DATADIR}/sounds/bitteringHops.mp3
     ${DATADIR}/sounds/checkBoil.mp3
     ${DATADIR}/sounds/checkFirstRunnings.mp3
     ${DATADIR}/sounds/checkGravity.mp3
     ${DATADIR}/sounds/checkHydrometer.mp3
     ${DATADIR}/sounds/checkMashTemps.mp3
     ${DATADIR}/sounds/checkTemp.mp3
     ${DATADIR}/sounds/clarifyingAgent.mp3
     ${DATADIR}/sounds/cleanup.mp3
     ${DATADIR}/sounds/closeFuckinValves.mp3
     ${DATADIR}/sounds/closeValves.mp3
     ${DATADIR}/sounds/doughIn.mp3
     ${DATADIR}/sounds/drinkAnotherHomebrew.mp3
     ${DATADIR}/sounds/drinkHomebrew.mp3
     ${DATADIR}/sounds/emptyMashTun.mp3
     ${DATADIR}/sounds/extraPropane.mp3
     ${DATADIR}/sounds/flameout.mp3
     ${DATADIR}/sounds/flavorHops.mp3
     ${DATADIR}/sounds/heatWater.mp3
     ${DATADIR}/sounds/mashHops.mp3
     ${DATADIR}/sounds/pitchYeast.mp3
     ${DATADIR}/sounds/sanitize.mp3
     ${DATADIR}/sounds/sparge.mp3
     ${DATADIR}/sounds/startBurner.mp3
     ${DATADIR}/sounds/startChill.mp3
     ${DATADIR}/sounds/stirMash.mp3
)

SET( brewtarget_INFO_PLIST "${ROOTDIR}/mac/Info.plist" )

SET( brewtarget_MAC_ICNS "${ROOTDIR}/mac/BrewtargetIcon.icns" )

#==========================Find dlls for Win32=================================

IF( WIN32 )
   SET( Qt_DLLs
        ${QT_BINARY_DIR}/phonon4.dll
        ${QT_BINARY_DIR}/QtCore4.dll
        ${QT_BINARY_DIR}/QtGui4.dll
        ${QT_BINARY_DIR}/QtNetwork4.dll
        ${QT_BINARY_DIR}/QtSvg4.dll
        ${QT_BINARY_DIR}/QtSql4.dll
        ${QT_BINARY_DIR}/QtWebKit4.dll
        ${QT_BINARY_DIR}/QtXml4.dll
   )
   
   SET( SQL_Drivers_DLLs
        ${QT_PLUGINS_DIR}/sqldrivers/qsqlite4.dll
   )

   SET( Phonon_Backend_DLLs
        ${QT_PLUGINS_DIR}/phonon_backend/phonon_ds94.dll
   )
   SET( Image_Formats_DLLs
        ${QT_PLUGINS_DIR}/imageformats/qgif4.dll
        ${QT_PLUGINS_DIR}/imageformats/qico4.dll
        ${QT_PLUGINS_DIR}/imageformats/qjpeg4.dll
        ${QT_PLUGINS_DIR}/imageformats/qmng4.dll
        ${QT_PLUGINS_DIR}/imageformats/qsvg4.dll
        ${QT_PLUGINS_DIR}/imageformats/qtiff4.dll
   )
   SET( Icon_Engines_DLLs
        ${QT_PLUGINS_DIR}/iconengines/qsvgicon4.dll
   )

   # Find extra MinGW-specific dlls.
   IF( MINGW )
      IF( NOT MINGW_BIN_DIR )

=== QtDesignerPlugins/CMakeLists.txt ===
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

INCLUDE( ${QT_USE_FILE} )
INCLUDE_DIRECTORIES(
   ${QT_INCLUDE_DIR}
   ${SRCDIR}
)

LINK_DIRECTORIES(
   ${QT_LIBRARY_DIR}
)

# By default only QtCore and QtGui are enabled
SET( QT_USE_QTDESIGNER TRUE )

SET( SRC_FILES
    ${SRCDIR}/BeerColorWidget.cpp
    ${SRCDIR}/BrewDayScrollWidget.cpp
    ${SRCDIR}/CustomComboBox.cpp
    ${SRCDIR}/EquipmentButton.cpp
    ${SRCDIR}/MaltinessWidget.cpp
    ${SRCDIR}/RecipeExtrasWidget.cpp

    ${SRCDIR}/BeerXMLElement.cpp
    ${SRCDIR}/brewnote.cpp
    ${SRCDIR}/brewtarget.cpp
    ${SRCDIR}/CelsiusTempUnitSystem.cpp
    ${SRCDIR}/database.cpp
    ${SRCDIR}/equipment.cpp
    ${SRCDIR}/FahrenheitTempUnitSystem.cpp
    ${SRCDIR}/fermentable.cpp
    ${SRCDIR}/HeatCalculations.cpp
    ${SRCDIR}/ImperialVolumeUnitSystem.cpp
    ${SRCDIR}/hop.cpp
    ${SRCDIR}/instruction.cpp
    ${SRCDIR}/mash.cpp
    ${SRCDIR}/mashstep.cpp
    ${SRCDIR}/misc.cpp
    ${SRCDIR}/recipe.cpp
    ${SRCDIR}/SIVolumeUnitSystem.cpp
    ${SRCDIR}/SIWeightUnitSystem.cpp
    ${SRCDIR}/style.cpp
    ${SRCDIR}/TimeUnitSystem.cpp
    ${SRCDIR}/unit.cpp
    ${SRCDIR}/UnitSystem.cpp
    ${SRCDIR}/UnitSystems.cpp
    ${SRCDIR}/USVolumeUnitSystem.cpp
    ${SRCDIR}/USWeightUnitSystem.cpp
    ${SRCDIR}/water.cpp
    ${SRCDIR}/yeast.cpp
)

SET( MOC_FILES
    ${SRCDIR}/BeerColorWidget.h
    ${SRCDIR}/BrewDayScrollWidget.h
    ${SRCDIR}/CustomComboBox.h
    ${SRCDIR}/EquipmentButton.h
    ${SRCDIR}/MaltinessWidget.h
    ${SRCDIR}/RecipeExtrasWidget.h

    ${SRCDIR}/BeerXMLElement.h
    ${SRCDIR}/brewnote.h
    ${SRCDIR}/database.h
    ${SRCDIR}/equipment.h
    ${SRCDIR}/fermentable.h
    ${SRCDIR}/hop.h
    ${SRCDIR}/instruction.h
    ${SRCDIR}/mash.h
    ${SRCDIR}/mashstep.h
    ${SRCDIR}/misc.h
    ${SRCDIR}/recipe.h
    ${SRCDIR}/style.h
    ${SRCDIR}/water.h
    ${SRCDIR}/yeast.h
)

set( UI_FILES
    ${UIDIR}/brewDayScrollWidget.ui
    ${UIDIR}/btSplashScreen.ui
    ${UIDIR}/instructionWidget.ui
    ${UIDIR}/mainWindow.ui
    ${UIDIR}/recipeExtrasWidget.ui
    ${UIDIR}/timerWidget.ui
)

SET( PLUGIN_MOCS
   BrewtargetPlugins.h
   BeerColorWidgetPlugin.h
   BrewDayScrollWidgetPlugin.h
   CustomComboBoxPlugin.h
   EquipmentButtonPlugin.h
   MaltinessWidgetPlugin.h
   RecipeExtrasWidgetPlugin.h
)

SET( PLUGIN_SRCS
   BrewtargetPlugins.cpp
   BeerColorWidgetPlugin.cpp
   BrewDayScrollWidgetPlugin.cpp
   CustomComboBoxPlugin.cpp
   EquipmentButtonPlugin.cpp
   MaltinessWidgetPlugin.cpp
   RecipeExtrasWidgetPlugin.cpp
)

QT4_WRAP_CPP( GEN_MOC_FILES ${MOC_FILES} ${PLUGIN_MOCS} )
QT4_WRAP_UI( GEN_UI_FILES ${UI_FILES})
QT4_ADD_RESOURCES( GEN_RCC_FILES "../brewtarget.qrc")
#QT4_WRAP_CPP( GEN_MOC_UI_FILES ${GEN_UI_FILES})

#========================All Plugins Together==================================

ADD_LIBRARY( brewtargetplugins SHARED
   ${SRC_FILES} 
   ${PLUGIN_SRCS}
   ${GEN_RCC_FILES}
   ${GEN_UI_FILES}
   ${GEN_MOC_FILES}
)

TARGET_LINK_LIBRARIES( brewtargetplugins
   ${QT_LIBRARIES}
)

INSTALL( TARGETS brewtargetplugins DESTINATION ${QT_PLUGINS_DIR}/designer )

=== src/CMakeLists.txt ===
# The current directory in the original source.
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )
# The current directory in the output build directory.
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

# Put all the required Qt dirs in the includes. 
#   That isn't quite what this include does. QT_USE_FILE references
#   a cmake macro include, which is good but not required.
INCLUDE(${QT_USE_FILE})

# (ADD_PCH_RULE  _header_filename _src_list)
# Version 7/26/2010
#
# use this macro before "add_executable"
#
# _header_filename
#  header to make a .gch
#
# _src_list 
#   the variable name (do not use ${..}) which contains a
#     a list of sources (a.cpp b.cpp c.cpp ...)
#  This macro will append a header file to it, then this src_list can be used in
#  "add_executable..."
#
#
# Now a .gch file should be generated and gcc should use it. 
#        (add -Winvalid-pch to the cpp flags to verify)
#
# make clean should delete the pch file
#
# example : ADD_PCH_RULE(headers.h myprog_SRCS)
MACRO (ADD_PCH_RULE  _header_filename _src_list)
   SET(_gch_filename "${CMAKE_CURRENT_BINARY_DIR}/${_header_filename}.gch")
   SET(_header "${CMAKE_CURRENT_SOURCE_DIR}/${_header_filename}")

   LIST(APPEND ${_src_list} ${_gch_filename})

   SET (_args ${CMAKE_CXX_FLAGS})
   LIST(APPEND _args -c ${_header} -o ${_gch_filename})

   GET_DIRECTORY_PROPERTY(DIRINC INCLUDE_DIRECTORIES)
   FOREACH(_inc ${DIRINC})
      LIST(APPEND _args "-I" ${_inc})
   ENDFOREACH(_inc ${DIRINC})

   SEPARATE_ARGUMENTS(_args)

   ADD_CUSTOM_COMMAND(OUTPUT ${_gch_filename}
                      COMMAND rm -f ${_gch_filename}
                      COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} ${_args}
                      DEPENDS ${_header})
ENDMACRO(ADD_PCH_RULE _src_list _header_filename)

# Variable that contains all the .cpp files in this project.
SET( brewtarget_SRCS
    ${SRCDIR}/Algorithms.cpp
    ${SRCDIR}/BeerXMLElement.cpp
    ${SRCDIR}/BeerXMLSortProxyModel.cpp
    ${SRCDIR}/BrewDayWidget.cpp
    ${SRCDIR}/BrewDayScrollWidget.cpp
    ${SRCDIR}/brewnote.cpp
    ${SRCDIR}/BrewNoteWidget.cpp
    ${SRCDIR}/BrewTargetTreeItem.cpp
    ${SRCDIR}/BrewTargetTreeModel.cpp
    ${SRCDIR}/BrewTargetTreeView.cpp
    ${SRCDIR}/BtTreeFilterProxyModel.cpp
    ${SRCDIR}/BeerColorWidget.cpp
    ${SRCDIR}/BtDatePopup.cpp
    ${SRCDIR}/BtLabel.cpp
    ${SRCDIR}/BtTextEdit.cpp
    ${SRCDIR}/brewtarget.cpp
    ${SRCDIR}/BtSplashScreen.cpp
    #${SRCDIR}/BtSqlQuery.cpp
    ${SRCDIR}/CelsiusTempUnitSystem.cpp
    ${SRCDIR}/ColorMethods.cpp
    ${SRCDIR}/ConverterTool.cpp
    ${SRCDIR}/CustomComboBox.cpp
    ${SRCDIR}/database.cpp
    ${SRCDIR}/equipment.cpp
    ${SRCDIR}/EquipmentButton.cpp
    ${SRCDIR}/EquipmentListModel.cpp
    ${SRCDIR}/EquipmentEditor.cpp
    ${SRCDIR}/FahrenheitTempUnitSystem.cpp
    ${SRCDIR}/fermentable.cpp
    ${SRCDIR}/FermentableEditor.cpp
    ${SRCDIR}/FermentableDialog.cpp
    ${SRCDIR}/FermentableSortFilterProxyModel.cpp
    ${SRCDIR}/FermentableTableModel.cpp
    ${SRCDIR}/main.cpp
    ${SRCDIR}/HeatCalculations.cpp
    ${SRCDIR}/hop.cpp
    ${SRCDIR}/HopDialog.cpp
    ${SRCDIR}/HopEditor.cpp
    ${SRCDIR}/HopSortFilterProxyModel.cpp
    ${SRCDIR}/HopTableModel.cpp
    ${SRCDIR}/instruction.cpp
    ${SRCDIR}/IbuMethods.cpp
    ${SRCDIR}/ImperialVolumeUnitSystem.cpp
    ${SRCDIR}/InstructionWidget.cpp
    ${SRCDIR}/MainWindow.cpp
    ${SRCDIR}/MaltinessWidget.cpp
    ${SRCDIR}/mash.cpp
    ${SRCDIR}/MashButton.cpp
    ${SRCDIR}/MashEditor.cpp
    ${SRCDIR}/MashListModel.cpp
    ${SRCDIR}/mashstep.cpp
    ${SRCDIR}/MashStepEditor.cpp
    ${SRCDIR}/MashStepTableModel.cpp
    ${SRCDIR}/MashStepTableWidget.cpp
    ${SRCDIR}/MashWizard.cpp
    ${SRCDIR}/matrix.cpp
    ${SRCDIR}/misc.cpp
    ${SRCDIR}/MiscEditor.cpp
    ${SRCDIR}/MiscDialog.cpp
    ${SRCDIR}/MiscSortFilterProxyModel.cpp
    ${SRCDIR}/MiscTableModel.cpp
    ${SRCDIR}/NamedMashEditor.cpp
    ${SRCDIR}/OgAdjuster.cpp
    ${SRCDIR}/OptionDialog.cpp
    ${SRCDIR}/PreInstruction.cpp
    ${SRCDIR}/PrimingDialog.cpp
    ${SRCDIR}/QueuedMethod.cpp
    ${SRCDIR}/recipe.cpp
    ${SRCDIR}/RecipeFormatter.cpp
    ${SRCDIR}/RecipeListModel.cpp
    ${SRCDIR}/RefractoDialog.cpp
    ${SRCDIR}/SetterCommand.cpp
    ${SRCDIR}/SetterCommandStack.cpp
    ${SRCDIR}/ScaleRecipeTool.cpp
    ${SRCDIR}/SIVolumeUnitSystem.cpp
    ${SRCDIR}/SIWeightUnitSystem.cpp
    ${SRCDIR}/style.cpp
    ${SRCDIR}/StyleButton.cpp
    ${SRCDIR}/StyleListModel.cpp
    ${SRCDIR}/StyleEditor.cpp
    ${SRCDIR}/StyleSortFilterProxyModel.cpp
    ${SRCDIR}/TimerListDialog.cpp
    ${SRCDIR}/TimerWidget.cpp
    ${SRCDIR}/TimeUnitSystem.cpp
    ${SRCDIR}/unit.cpp
    ${SRCDIR}/UnitSystem.cpp
    ${SRCDIR}/UnitSystems.cpp
    ${SRCDIR}/USVolumeUnitSystem.cpp
    ${SRCDIR}/USWeightUnitSystem.cpp
    ${SRCDIR}/water.cpp
    ${SRCDIR}/WaterTableModel.cpp
    ${SRCDIR}/WaterTableWidget.cpp
    ${SRCDIR}/WaterEditor.cpp
    ${SRCDIR}/yeast.cpp
    ${SRCDIR}/YeastDialog.cpp
    ${SRCDIR}/YeastEditor.cpp
    ${SRCDIR}/YeastTableModel.cpp
    ${SRCDIR}/YeastSortFilterProxyModel.cpp
    ${SRCDIR}/RecipeExtrasDialog.cpp
    ${SRCDIR}/MashDesigner.cpp
    ${SRCDIR}/BtDigitWidget.cpp
    ${SRCDIR}/PitchDialog.cpp
    ${SRCDIR}/RecipeExtrasWidget.cpp
)

# List of all the *.ui.
# TODO: can I somehow have a separate CMakeLists.txt
# in the ui/ directory instead of here?
SET( brewtarget_UIS
    ${UIDIR}/aboutDialog.ui
    ${UIDIR}/brewDayWidget.ui
    ${UIDIR}/brewDayScrollWidget.ui
    ${UIDIR}/brewNoteWidget.ui
    ${UIDIR}/btSplashScreen.ui
    ${UIDIR}/converterTool.ui
    ${UIDIR}/mainWindow.ui
    ${UIDIR}/mashStepEditor.ui
    ${UIDIR}/miscEditor.ui
    ${UIDIR}/fermentableEditor.ui
    ${UIDIR}/fermentableDialog.ui
    ${UIDIR}/equipmentEditor.ui
    ${UIDIR}/hopDialog.ui
    ${UIDIR}/hopEditor.ui
    ${UIDIR}/htmlViewer.ui
    ${UIDIR}/instructionWidget.ui
    ${UIDIR}/mashEditor.ui
    ${UIDIR}/namedMashEditor.ui
    ${UIDIR}/mashWizard.ui
    ${UIDIR}/miscDialog.ui
    ${UIDIR}/ogAdjuster.ui
    ${UIDIR}/optionsDialog.ui
    ${UIDIR}/primingDialog.ui
    ${UIDIR}/recipeExtrasDialog.ui
    ${UIDIR}/refractoDialog.ui
    ${UIDIR}/scaleRecipeTool.ui
    ${UIDIR}/styleEditor.ui
    ${UIDIR}/timerListDialog.ui
    ${UIDIR}/timerWidget.ui
    ${UIDIR}/waterEditor.ui
    ${UIDIR}/yeastDialog.ui
    ${UIDIR}/yeastEditor.ui
    ${UIDIR}/mashDesigner.ui
    ${UIDIR}/pitchDialog.ui
    ${UIDIR}/brewDayScrollWidget.ui
    ${UIDIR}/recipeExtrasWidget.ui
)

# The list of files that need to be moc'd.
# In other words, classes that have Q_OBJECT declarations and stuff.
SET( brewtarget_MOC_HEADERS
    ${SRCDIR}/BeerColorWidget.h
    ${SRCDIR}/BeerXMLElement.h
    ${SRCDIR}/BeerXMLSortProxyModel.h
    ${SRCDIR}/BrewDayWidget.h
    ${SRCDIR}/BrewDayScrollWidget.h
    ${SRCDIR}/brewnote.h
    ${SRCDIR}/BrewNoteWidget.h
    ${SRCDIR}/brewtarget.h
    ${SRCDIR}/BrewTargetTreeModel.h
    ${SRCDIR}/BrewTargetTreeView.h
    ${SRCDIR}/BtTreeFilterProxyModel.h
    ${SRCDIR}/BtDigitWidget.h
    ${SRCDIR}/BtDatePopup.h
    ${SRCDIR}/BtLabel.h
    ${SRCDIR}/BtTextEdit.h
    ${SRCDIR}/BtSplashScreen.h
    #${SRCDIR}/BtSqlQuery.h
    ${SRCDIR}/ConverterTool.h
    ${SRCDIR}/CustomComboBox.h
    ${SRCDIR}/database.h
    ${SRCDIR}/EquipmentButton.h
    ${SRCDIR}/EquipmentListModel.h
    ${SRCDIR}/EquipmentEditor.h
    ${SRCDIR}/FermentableEditor.h
    ${SRCDIR}/FermentableDialog.h
    ${SRCDIR}/FermentableSortFilterProxyModel.h
    ${SRCDIR}/FermentableTableModel.h
    ${SRCDIR}/HopDialog.h
    ${SRCDIR}/HopEditor.h
    ${SRCDIR}/HopSortFilterProxyModel.h
    ${SRCDIR}/HopTableModel.h
    ${SRCDIR}/InstructionWidget.h
    ${SRCDIR}/MainWindow.h
    ${SRCDIR}/MaltinessWidget.h
    ${SRCDIR}/MashButton.h
    ${SRCDIR}/MashDesigner.h
    ${SRCDIR}/MashEditor.h
    ${SRCDIR}/NamedMashEditor.h
    ${SRCDIR}/MashListModel.h
    ${SRCDIR}/MashStepEditor.h
    ${SRCDIR}/MashStepTableModel.h
    ${SRCDIR}/MashStepTableWidget.h
    ${SRCDIR}/MashWizard.h
    ${SRCDIR}/MiscDialog.h
    ${SRCDIR}/MiscEditor.h
    ${SRCDIR}/MiscSortFilterProxyModel.h
    ${SRCDIR}/MiscTableModel.h
    ${SRCDIR}/OgAdjuster.h
    ${SRCDIR}/OptionDialog.h
    ${SRCDIR}/PitchDialog.h
    ${SRCDIR}/PrimingDialog.h
    ${SRCDIR}/QueuedMethod.h
    ${SRCDIR}/RecipeExtrasDialog.h
    ${SRCDIR}/RecipeExtrasWidget.h
    ${SRCDIR}/RecipeFormatter.h
    ${SRCDIR}/RecipeListModel.h
    ${SRCDIR}/RefractoDialog.h
    ${SRCDIR}/ScaleRecipeTool.h
    ${SRCDIR}/SetterCommandStack.h
    ${SRCDIR}/StyleButton.h
    ${SRCDIR}/StyleListModel.h
    ${SRCDIR}/StyleEditor.h
    ${SRCDIR}/StyleSortFilterProxyModel.h
    ${SRCDIR}/TimerListDialog.h
    ${SRCDIR}/TimerWidget.h
    ${SRCDIR}/unit.h
    ${SRCDIR}/WaterTableModel.h
    ${SRCDIR}/WaterTableWidget.h
    ${SRCDIR}/WaterEditor.h
    ${SRCDIR}/YeastDialog.h
    ${SRCDIR}/YeastEditor.h
    ${SRCDIR}/YeastSortFilterProxyModel.h
    ${SRCDIR}/YeastTableModel.h
    ${SRCDIR}/equipment.h
    ${SRCDIR}/fermentable.h
    ${SRCDIR}/hop.h
    ${SRCDIR}/instruction.h
    ${SRCDIR}/mash.h
    ${SRCDIR}/mashstep.h
    ${SRCDIR}/misc.h
    ${SRCDIR}/recipe.h
    ${SRCDIR}/style.h
    ${SRCDIR}/water.h
    ${SRCDIR}/yeast.h
)

SET( FILES_TO_TRANSLATE
     ${brewtarget_SRCS}
     ${brewtarget_UIS}
)

#======Speed up compilation by using precompiled headers for development======
#IF( UNIX AND NOT APPLE )
#   SET( precompiled_h "equipment.h" "fermentable.h" "hop.h" "instruction.h" "mash.h" "mashstep.h" "misc.h" "recipe.h" "style.h" "unit.h" "water.h" "yeast.h" "database.h" "brewtarget.h" )
#   FOREACH( header ${precompiled_h} )
#      ADD_PCH_RULE( ${header} brewtarget_SRCS )
#   ENDFOREACH()
#ENDIF()

#======================Some Custom Targets/Commands============================

# Creates a target for ${CMAKE_CURRENT_BINARY_DIR}/blankdb.sqlite needed by
# the brewtarget.qrc resource file.
ADD_CUSTOM_COMMAND( OUTPUT blankdb.sqlite
                    COMMAND ${RM_COMMAND} ARGS ${RM_ARGS} "blankdb.sqlite" # Need to remove it if it exists first.
                    COMMAND ${SQLITE3_CMD} ARGS "blankdb.sqlite" "<" "${ROOTDIR}/create_db.sql"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                    MAIN_DEPENDENCY "${ROOTDIR}/create_db.sql"
)

#==================================Qt Junk=====================================

# Create the moc sources from the headers.
QT4_WRAP_CPP(brewtarget_MOC_SRCS ${brewtarget_MOC_HEADERS})

# Create the ui_*.h files from the *.ui files.
QT4_WRAP_UI(brewtarget_UIS_H ${brewtarget_UIS})

# Generate the resource .cpp from the .qrc file.
QT4_ADD_RESOURCES(brewtarget_QRC_CPP ${brewtarget_QRC})
QT4_ADD_RESOURCES(brewtarget_cfg_QRC_CPP ${brewtarget_cfg_QRC})

# Translations
FIND_PROGRAM( LUPDATE_CMD lupdate-qt4 )
IF( LUPDATE_CMD )
  ADD_CUSTOM_TARGET(
     update_translations
     COMMAND ${LUPDATE_CMD} "-no-obsolete" ${FILES_TO_TRANSLATE} "-ts" ${TRANSLATIONS_FILES}
  )
ENDIF()
# Creates the .qm files.
QT4_ADD_TRANSLATION(QM_FILES ${TRANSLATIONS_FILES})

# Add a target for the QM_FILES so that we can add
# the translations as a dependency for the executable later.
ADD_CUSTOM_TARGET(translations DEPENDS ${QM_FILES})

#============================Icon for Windows==================================

IF( WIN32 AND MINGW )
  ADD_CUSTOM_COMMAND(OUTPUT ${WINDIR}/icon.o
                     COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
                     -i${RCFILE}
                     -o${WINDIR}/icon.o
                     DEPENDS ${RCFILE}
  )
  SET(brewtarget_SRCS ${brewtarget_SRCS} ${WINDIR}/icon.o)
ELSEIF(WIN32)
  SET(brewtarget_SRCS ${brewtarget_SRCS} ${RCFILE})
ENDIF()

#===========================Create the binary==================================

ADD_EXECUTABLE( ${brewtarget_EXECUTABLE} ${brewtarget_SRCS} ${brewtarget_MOC_SRCS} ${brewtarget_QRC_CPP} ${brewtarget_cfg_QRC_CPP} ${brewtarget_UIS_H} )
ADD_DEPENDENCIES( ${brewtarget_EXECUTABLE} translations )

# Link brewtarget against appropriate libraries.
IF( WIN32 AND MINGW )

=== debian/changelog ===
brewtarget (2.0.2-1) unstable; urgency=low

  * New upstream release
  * Updated copyright years.
  * Changed references from sourceforge.net to brewtarget.org.
  * Bumped standards-version to 3.9.5.
  * Requires debhelper > 9.0.

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 11 Jan 2014 15:08:30 -0600

brewtarget (2.0.1-1) unstable; urgency=low

  * New upstream release
  * Now importing hardening flags.
  * Updated standards version to 3.9.4.
  * Updated compat to 9
  * Added libqtwebkit-dev to the build dependencies. 

 -- Philip G. Lee <rocketman768@gmail.com>  Mon, 17 Mar 2013 20:41:21 -0600

brewtarget (2.0.0-1) unstable; urgency=low

  * New upstream release

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 29 Dec 2012 09:02:42 -0500

=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Philip G. Lee <rocketman768@gmail.com>
Build-Depends: cmake (>= 2.8), debhelper (>= 9.0), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev, sqlite3, hardening-includes
Standards-Version: 3.9.5
Homepage: http://www.brewtarget.org

Package: brewtarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.

=== debian/rules ===
#!/usr/bin/make -f
install-dir = "$(shell pwd)/debian/brewtarget"
include /usr/share/hardening-includes/hardening.make

CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
CXXFLAGS+=$(HARDENING_CFLAGS)
LDFLAGS+=$(HARDENING_LDFLAGS)

override_dh_auto_configure:
	if ! test -d build; then mkdir build; fi
	if ! test -d build/cmake; then mkdir build/cmake; fi
	cd build/cmake; \
	cmake ../../ -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" -DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" -DDO_RELEASE_BUILD=ON -DNO_MESSING_WITH_FLAGS=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=usr

override_dh_auto_build:
	cd build/cmake; \
	make

override_dh_auto_install:
	cd build/cmake; \
	make install

override_dh_clean:
	dh_clean
	if test -d build/cmake; then rm -r build/cmake; fi
	if test -e src/config.h; then rm src/config.h; fi
	if test -d debian/brewtarget; then rm -r debian/brewtarget; fi

%:
	dh $@

## brewtarget 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PROJECT(brewtarget)
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8.8)
 
 # Creates a Makefile.
 # NOTE: cmake . -DCMAKE_INSTALL_PREFIX=/tmp/blah && make DESTDIR=/foo
@@ -10,8 +10,8 @@
 
 #=================================Version======================================
 SET( brewtarget_VERSION_MAJOR 2 )
-SET( brewtarget_VERSION_MINOR 0 )
-SET( brewtarget_VERSION_PATCH 2 )
+SET( brewtarget_VERSION_MINOR 1 )
+SET( brewtarget_VERSION_PATCH 0 )
 SET( brewtarget_VERSION_STRING "${brewtarget_VERSION_MAJOR}.${brewtarget_VERSION_MINOR}.${brewtarget_VERSION_PATCH}" )
 
 #===================================Options====================================
@@ -30,6 +30,10 @@
 OPTION( NO_MESSING_WITH_FLAGS
         "On means do not add any build flags whatsoever. May override other options."
         OFF )
+
+# Do this right off the bat
+ENABLE_TESTING()
+
 #==============================Compile flags===================================
 IF( NOT ${NO_MESSING_WITH_FLAGS} )
    IF( CMAKE_COMPILER_IS_GNUCXX )
@@ -59,7 +63,8 @@
 ENDIF()
 
 IF( APPLE AND NOT CMAKE_OSX_ARCHITECTURES )
-   SET( CMAKE_OSX_ARCHITECTURES i386 x86_64 ) # Build intel binary. 
+   SET( CMAKE_OSX_ARCHITECTURES x86_64 ) # Build intel 64-bit binary. 
+   #SET( CMAKE_OSX_ARCHITECTURES i386 x86_64 ) # Build intel binary. 
    #SET( CMAKE_OSX_ARCHITECTURES ppc i386 ppc64 x86_64 ) # Build universal binary.
 ENDIF()
 
@@ -89,9 +94,15 @@
 
 # ======================Find Qt4 (>= 4.6.0) for this project===================
 IF( ${BUILD_DESIGNER_PLUGINS} )
-   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebKit QtXml QtDesigner REQUIRED)
+   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebKit QtXml QtDesigner REQUIRED)
 ELSE()
-   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtSvg QtWebkit QtXml REQUIRED)
+   # This is a major kludge, but linking with QtSvg is the easiest way to get
+   # an app that includes the svg image format plugin that works.
+   IF( APPLE )
+      FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebkit QtXml QtSvg REQUIRED)
+   ELSE()
+      FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSql QtWebkit QtXml REQUIRED)
+   ENDIF()
 ENDIF()
 
 MESSAGE( STATUS "CMAKE_SYSTEM_INCLUDE_PATH: ${CMAKE_SYSTEM_INCLUDE_PATH}" )
@@ -120,8 +131,6 @@
 #=========================Configure brewtarget.qrc.in==========================
 
 SET( brewtarget_QRC "${CMAKE_CURRENT_SOURCE_DIR}/brewtarget.qrc" )
-SET( brewtarget_cfg_QRC "${CMAKE_CURRENT_BINARY_DIR}/brewtarget_cfg.qrc" )
-CONFIGURE_FILE( brewtarget_cfg.qrc.in ${brewtarget_cfg_QRC} )
 
 #============================Doxygen Custom Target=============================
 FIND_PROGRAM( DOXYGEN_CMD doxygen )
@@ -132,12 +141,6 @@
                      COMMAND ${DOXYGEN_CMD} ${DOXYFILE}
                      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
                    )
-ENDIF()
-
-#=============================Database Custom Target===========================
-FIND_PROGRAM( SQLITE3_CMD sqlite3 )
-IF( NOT SQLITE3_CMD )
-   MESSAGE( FATAL_ERROR "Did not find sqlite3 to make the database." )
 ENDIF()
 
 #=========================Detect Debian======================================== 
@@ -192,17 +195,6 @@
   SET( DOCPATH  "${BT_BUNDLE_DIR}/Contents/Resources/en.lproj" )
 ENDIF()
 
-#=========================Configure brewtarget.desktop=========================
-
-# If it begins with a '/'
-IF( IS_ABSOLUTE ${DATAROOTDIR} )
-   SET( brewtarget_ICONS_LOCATION "${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
-ELSE()
-   SET( brewtarget_ICONS_LOCATION "/${DATAROOTDIR}/icons/${CMAKE_PROJECT_NAME}" )
-ENDIF()
-
-CONFIGURE_FILE( brewtarget.desktop.in brewtarget.desktop )
-
 #==============================Setup the config.h==============================
 
 # "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
@@ -237,22 +229,19 @@
 # List of data files to be installed.
 SET( brewtarget_DATA
      ${DATADIR}/default_db.sqlite
-     ${DATADIR}/options.xml
 # Yes, I know this is 'documentation', but Debian policy suggests it should be
 # with the data (see section 12.3 of the policy manual).
      ${ROOTDIR}/doc/brewtarget-manual.html
 )
 
 # Desktop files to install.
-# This is not prefixed with ${ROOTDIR} b/c it is a configured file that will
-# only exist in the build directory.
 SET( brewtarget_DESKTOP
-     ${CMAKE_CURRENT_BINARY_DIR}/brewtarget.desktop
+     ${ROOTDIR}/brewtarget.desktop
 )
 
 # Icon files to install.
 SET( brewtarget_ICONS
-     ${ROOTDIR}/images/brewtarget_icon.svg
+     ${ROOTDIR}/images/brewtarget.svg
 )
 
 SET( TRANSLATIONS_FILES
@@ -348,3 +337,19 @@
    # Find extra MinGW-specific dlls.
    IF( MINGW )
       IF( NOT MINGW_BIN_DIR )
+         FIND_PATH(MINGW_BIN_DIR "mingw32-c++.exe")
+      ENDIF()
+     
+     IF( NOT EXISTS ${MINGW_BIN_DIR} )
+        MESSAGE( FATAL_ERROR "MinGW bin dir not found. Run cmake again with the option -DMINGW_BIN_DIR=c:/path/to/mingw" )
+     ELSE()
+        SET( Qt_DLLs
+             ${Qt_DLLs}
+             ${MINGW_BIN_DIR}/libgcc_s_dw2-1.dll
+             ${MINGW_BIN_DIR}/libstdc++-6.dll
+             ${MINGW_BIN_DIR}/mingwm10.dll
+        )
+     ENDIF()
+   ENDIF()
+ENDIF()
+

=== QtDesignerPlugins/CMakeLists.txt ===
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

INCLUDE( ${QT_USE_FILE} )
INCLUDE_DIRECTORIES(
   ${QT_INCLUDE_DIR}
   ${SRCDIR}
)

LINK_DIRECTORIES(
   ${QT_LIBRARY_DIR}
)

# By default only QtCore and QtGui are enabled
SET( QT_USE_QTDESIGNER TRUE )

SET( SRC_FILES
   ${SRCDIR}/IbuGuSlider.cpp
   ${SRCDIR}/RangedSlider.cpp
   ${SRCDIR}/StyleRangeWidget.cpp
)

SET( MOC_FILES
   ${SRCDIR}/IbuGuSlider.h
   ${SRCDIR}/RangedSlider.h
   ${SRCDIR}/StyleRangeWidget.h
)

set( UI_FILES
)

SET( PLUGIN_MOCS
   BrewtargetPlugins.h
   IbuGuSliderPlugin.h
   StyleRangeWidgetPlugin.h
)

SET( PLUGIN_SRCS
   BrewtargetPlugins.cpp
   IbuGuSliderPlugin.cpp
   StyleRangeWidgetPlugin.cpp
)

QT4_WRAP_CPP( GEN_MOC_FILES ${MOC_FILES} ${PLUGIN_MOCS} )
QT4_WRAP_UI( GEN_UI_FILES ${UI_FILES})

#========================All Plugins Together==================================

ADD_LIBRARY( brewtargetplugins SHARED
   ${SRC_FILES} 
   ${PLUGIN_SRCS}
   ${GEN_UI_FILES}
   ${GEN_MOC_FILES}
)

TARGET_LINK_LIBRARIES( brewtargetplugins
   ${QT_LIBRARIES}
)

INSTALL( TARGETS brewtargetplugins DESTINATION ${QT_PLUGINS_DIR}/designer )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,22 +60,24 @@
     ${SRCDIR}/BrewDayScrollWidget.cpp
     ${SRCDIR}/brewnote.cpp
     ${SRCDIR}/BrewNoteWidget.cpp
-    ${SRCDIR}/BrewTargetTreeItem.cpp
-    ${SRCDIR}/BrewTargetTreeModel.cpp
-    ${SRCDIR}/BrewTargetTreeView.cpp
+    ${SRCDIR}/BtTabWidget.cpp
+    ${SRCDIR}/BtTreeItem.cpp
+    ${SRCDIR}/BtTreeModel.cpp
+    ${SRCDIR}/BtTreeView.cpp
     ${SRCDIR}/BtTreeFilterProxyModel.cpp
     ${SRCDIR}/BeerColorWidget.cpp
     ${SRCDIR}/BtDatePopup.cpp
+    ${SRCDIR}/BtFolder.cpp
     ${SRCDIR}/BtLabel.cpp
     ${SRCDIR}/BtTextEdit.cpp
     ${SRCDIR}/brewtarget.cpp
     ${SRCDIR}/BtSplashScreen.cpp
-    #${SRCDIR}/BtSqlQuery.cpp
     ${SRCDIR}/CelsiusTempUnitSystem.cpp
     ${SRCDIR}/ColorMethods.cpp
     ${SRCDIR}/ConverterTool.cpp
     ${SRCDIR}/CustomComboBox.cpp
     ${SRCDIR}/database.cpp
+    ${SRCDIR}/DatabaseSchemaHelper.cpp
     ${SRCDIR}/equipment.cpp
     ${SRCDIR}/EquipmentButton.cpp
     ${SRCDIR}/EquipmentListModel.cpp
@@ -86,7 +88,6 @@
     ${SRCDIR}/FermentableDialog.cpp
     ${SRCDIR}/FermentableSortFilterProxyModel.cpp
     ${SRCDIR}/FermentableTableModel.cpp
-    ${SRCDIR}/main.cpp
     ${SRCDIR}/HeatCalculations.cpp
     ${SRCDIR}/hop.cpp
     ${SRCDIR}/HopDialog.cpp
@@ -94,11 +95,11 @@
     ${SRCDIR}/HopSortFilterProxyModel.cpp
     ${SRCDIR}/HopTableModel.cpp
     ${SRCDIR}/instruction.cpp
+    ${SRCDIR}/IbuGuSlider.cpp
     ${SRCDIR}/IbuMethods.cpp
     ${SRCDIR}/ImperialVolumeUnitSystem.cpp
     ${SRCDIR}/InstructionWidget.cpp
     ${SRCDIR}/MainWindow.cpp
-    ${SRCDIR}/MaltinessWidget.cpp
     ${SRCDIR}/mash.cpp
     ${SRCDIR}/MashButton.cpp
     ${SRCDIR}/MashEditor.cpp
@@ -120,19 +121,21 @@
     ${SRCDIR}/PreInstruction.cpp
     ${SRCDIR}/PrimingDialog.cpp
     ${SRCDIR}/QueuedMethod.cpp
+    ${SRCDIR}/RangedSlider.cpp
     ${SRCDIR}/recipe.cpp
     ${SRCDIR}/RecipeFormatter.cpp
-    ${SRCDIR}/RecipeListModel.cpp
     ${SRCDIR}/RefractoDialog.cpp
     ${SRCDIR}/SetterCommand.cpp
     ${SRCDIR}/SetterCommandStack.cpp
     ${SRCDIR}/ScaleRecipeTool.cpp
     ${SRCDIR}/SIVolumeUnitSystem.cpp
     ${SRCDIR}/SIWeightUnitSystem.cpp
+    ${SRCDIR}/StrikeWaterDialog.cpp
     ${SRCDIR}/style.cpp
     ${SRCDIR}/StyleButton.cpp
     ${SRCDIR}/StyleListModel.cpp
     ${SRCDIR}/StyleEditor.cpp
+    ${SRCDIR}/StyleRangeWidget.cpp
     ${SRCDIR}/StyleSortFilterProxyModel.cpp
     ${SRCDIR}/TimerListDialog.cpp
     ${SRCDIR}/TimerWidget.cpp
@@ -188,6 +191,7 @@
     ${UIDIR}/recipeExtrasDialog.ui
     ${UIDIR}/refractoDialog.ui
     ${UIDIR}/scaleRecipeTool.ui
+    ${UIDIR}/strikeWaterDialog.ui
     ${UIDIR}/styleEditor.ui
     ${UIDIR}/timerListDialog.ui
     ${UIDIR}/timerWidget.ui
@@ -211,15 +215,16 @@
     ${SRCDIR}/brewnote.h
     ${SRCDIR}/BrewNoteWidget.h
     ${SRCDIR}/brewtarget.h
-    ${SRCDIR}/BrewTargetTreeModel.h
-    ${SRCDIR}/BrewTargetTreeView.h
+    ${SRCDIR}/BtTabWidget.h
+    ${SRCDIR}/BtTreeModel.h
+    ${SRCDIR}/BtTreeView.h
     ${SRCDIR}/BtTreeFilterProxyModel.h
     ${SRCDIR}/BtDigitWidget.h
     ${SRCDIR}/BtDatePopup.h
+    ${SRCDIR}/BtFolder.h
     ${SRCDIR}/BtLabel.h
     ${SRCDIR}/BtTextEdit.h
     ${SRCDIR}/BtSplashScreen.h
-    #${SRCDIR}/BtSqlQuery.h
     ${SRCDIR}/ConverterTool.h
     ${SRCDIR}/CustomComboBox.h
     ${SRCDIR}/database.h
@@ -234,9 +239,9 @@
     ${SRCDIR}/HopEditor.h
     ${SRCDIR}/HopSortFilterProxyModel.h
     ${SRCDIR}/HopTableModel.h
+    ${SRCDIR}/IbuGuSlider.h
     ${SRCDIR}/InstructionWidget.h
     ${SRCDIR}/MainWindow.h
-    ${SRCDIR}/MaltinessWidget.h
     ${SRCDIR}/MashButton.h
     ${SRCDIR}/MashDesigner.h
     ${SRCDIR}/MashEditor.h
@@ -255,16 +260,18 @@
     ${SRCDIR}/PitchDialog.h
     ${SRCDIR}/PrimingDialog.h
     ${SRCDIR}/QueuedMethod.h
+    ${SRCDIR}/RangedSlider.h
     ${SRCDIR}/RecipeExtrasDialog.h
     ${SRCDIR}/RecipeExtrasWidget.h
     ${SRCDIR}/RecipeFormatter.h
-    ${SRCDIR}/RecipeListModel.h
     ${SRCDIR}/RefractoDialog.h
     ${SRCDIR}/ScaleRecipeTool.h
     ${SRCDIR}/SetterCommandStack.h
+    ${SRCDIR}/StrikeWaterDialog.h
     ${SRCDIR}/StyleButton.h
     ${SRCDIR}/StyleListModel.h
     ${SRCDIR}/StyleEditor.h
+    ${SRCDIR}/StyleRangeWidget.h
     ${SRCDIR}/StyleSortFilterProxyModel.h
     ${SRCDIR}/TimerListDialog.h
     ${SRCDIR}/TimerWidget.h
@@ -302,17 +309,6 @@
 #   ENDFOREACH()
 #ENDIF()
 
-#======================Some Custom Targets/Commands============================
-
-# Creates a target for ${CMAKE_CURRENT_BINARY_DIR}/blankdb.sqlite needed by
-# the brewtarget.qrc resource file.
-ADD_CUSTOM_COMMAND( OUTPUT blankdb.sqlite
-                    COMMAND ${RM_COMMAND} ARGS ${RM_ARGS} "blankdb.sqlite" # Need to remove it if it exists first.
-                    COMMAND ${SQLITE3_CMD} ARGS "blankdb.sqlite" "<" "${ROOTDIR}/create_db.sql"
-                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-                    MAIN_DEPENDENCY "${ROOTDIR}/create_db.sql"
-)
-
 #==================================Qt Junk=====================================
 
 # Create the moc sources from the headers.
@@ -323,7 +319,6 @@
 
 # Generate the resource .cpp from the .qrc file.
 QT4_ADD_RESOURCES(brewtarget_QRC_CPP ${brewtarget_QRC})
-QT4_ADD_RESOURCES(brewtarget_cfg_QRC_CPP ${brewtarget_cfg_QRC})
 
 # Translations
 FIND_PROGRAM( LUPDATE_CMD lupdate-qt4 )
@@ -342,6 +337,8 @@
 
 #============================Icon for Windows==================================
 
+SET(brewtarget_ICON "")
+
 IF( WIN32 AND MINGW )
   ADD_CUSTOM_COMMAND(OUTPUT ${WINDIR}/icon.o
                      COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
@@ -349,15 +346,36 @@
                      -o${WINDIR}/icon.o
                      DEPENDS ${RCFILE}
   )
-  SET(brewtarget_SRCS ${brewtarget_SRCS} ${WINDIR}/icon.o)
+  SET(brewtarget_ICON ${WINDIR}/icon.o)
 ELSEIF(WIN32)
-  SET(brewtarget_SRCS ${brewtarget_SRCS} ${RCFILE})
+  SET(brewtarget_ICON ${RCFILE})
 ENDIF()
 
 #===========================Create the binary==================================
 
-ADD_EXECUTABLE( ${brewtarget_EXECUTABLE} ${brewtarget_SRCS} ${brewtarget_MOC_SRCS} ${brewtarget_QRC_CPP} ${brewtarget_cfg_QRC_CPP} ${brewtarget_UIS_H} )
+# This creates a "library" of object files so that we do not have to recompile
+# the source files once per target, but rather, just once EVER.
+ADD_LIBRARY(
+   btobjlib
+   OBJECT
+   ${brewtarget_SRCS}
+   ${brewtarget_MOC_SRCS}
+   ${brewtarget_QRC_CPP}
+   ${brewtarget_UIS_H}
+)
+
+ADD_EXECUTABLE(
+   ${brewtarget_EXECUTABLE}
+   ${SRCDIR}/main.cpp
+   ${brewtarget_ICON}
+   $<TARGET_OBJECTS:btobjlib>
+)
 ADD_DEPENDENCIES( ${brewtarget_EXECUTABLE} translations )
 
 # Link brewtarget against appropriate libraries.
 IF( WIN32 AND MINGW )
+   ############################################################################
+   # Need to set some linker flags that I don't know how to get
+   # automatically.
+   ############################################################################
+

=== debian/changelog ===
brewtarget (2.1.0-1) unstable; urgency=low

  * New upstream release
  * Converted debian/copyright to machine-readable format
  * Removed deprecated hardening-includes, using dpkg-buildflags
  * Removed sqlite3 build dependency

 -- Philip G. Lee <rocketman768@gmail.com>  Sun, 14 Sep 2014 13:41:30 -0500

brewtarget (2.0.3-1) unstable; urgency=low

  * New upstream release

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 03 May 2014 09:38:30 -0500

=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Philip G. Lee <rocketman768@gmail.com>
Build-Depends: cmake (>= 2.8), debhelper (>= 9.0), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev
Standards-Version: 3.9.5
Homepage: http://www.brewtarget.org

Package: brewtarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, libqt4-svg
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,10 @@
 #!/usr/bin/make -f
 install-dir = "$(shell pwd)/debian/brewtarget"
-include /usr/share/hardening-includes/hardening.make
 
+CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
 LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
-CXXFLAGS+=$(HARDENING_CFLAGS)
-LDFLAGS+=$(HARDENING_LDFLAGS)
 
 override_dh_auto_configure:
 	if ! test -d build; then mkdir build; fi
